Index: code/trunk/src/modules/overlays/hud/HUDBar.cc
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDBar.cc	(revision 7380)
+++ code/trunk/src/modules/overlays/hud/HUDBar.cc	(revision 7401)
@@ -55,10 +55,10 @@
     }
 
-    void BarColour::XMLPort(Element& xmlElement, XMLPort::Mode mode)
-    {
-        SUPER(BarColour, XMLPort, xmlElement, mode);
-
-        XMLPortParam(BarColour, "colour", setColour, getColour, xmlElement, mode);
-        XMLPortParam(BarColour, "position", setPosition, getPosition, xmlElement, mode);
+    void BarColour::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(BarColour, XMLPort, xmlelement, mode);
+
+        XMLPortParam(BarColour, "colour", setColour, getColour, xmlelement, mode);
+        XMLPortParam(BarColour, "position", setPosition, getPosition, xmlelement, mode);
     }
 
@@ -104,13 +104,13 @@
     }
 
-    void HUDBar::XMLPort(Element& xmlElement, XMLPort::Mode mode)
-    {
-        SUPER(HUDBar, XMLPort, xmlElement, mode);
-
-        XMLPortParam(HUDBar, "initialvalue", setValue,       getValue,       xmlElement, mode);
-        XMLPortParam(HUDBar, "righttoleft",  setRightToLeft, getRightToLeft, xmlElement, mode);
-        XMLPortParam(HUDBar, "autocolour",   setAutoColour,  getAutoColour,  xmlElement, mode);
-        XMLPortParam(HUDBar, "bartexture",   setBarTexture,  getBarTexture, xmlElement, mode);
-        XMLPortObject(HUDBar, BarColour, "", addColour, getColour, xmlElement, mode);
+    void HUDBar::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(HUDBar, XMLPort, xmlelement, mode);
+
+        XMLPortParam(HUDBar, "initialvalue", setValue,       getValue,       xmlelement, mode);
+        XMLPortParam(HUDBar, "righttoleft",  setRightToLeft, getRightToLeft, xmlelement, mode);
+        XMLPortParam(HUDBar, "autocolour",   setAutoColour,  getAutoColour,  xmlelement, mode);
+        XMLPortParam(HUDBar, "bartexture",   setBarTexture,  getBarTexture, xmlelement, mode);
+        XMLPortObject(HUDBar, BarColour, "", addColour, getColour, xmlelement, mode);
     }
 
Index: code/trunk/src/modules/overlays/hud/HUDBar.h
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDBar.h	(revision 7380)
+++ code/trunk/src/modules/overlays/hud/HUDBar.h	(revision 7401)
@@ -50,5 +50,5 @@
         virtual ~BarColour() { }
 
-        virtual void XMLPort(Element& xmlElement, XMLPort::Mode mode);
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
         void setColour(const ColourValue& colour) { this->colour_ = colour; }
@@ -70,5 +70,5 @@
         virtual ~HUDBar();
 
-        virtual void XMLPort(Element& xmlElement, XMLPort::Mode mode);
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
         void clearColours();
Index: code/trunk/src/modules/overlays/hud/HUDHealthBar.h
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDHealthBar.h	(revision 7380)
+++ code/trunk/src/modules/overlays/hud/HUDHealthBar.h	(revision 7401)
@@ -45,5 +45,5 @@
             virtual ~HUDHealthBar();
 
-            virtual void XMLPort(Element& xmlElement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
             virtual void tick(float dt);
             virtual void changedOwner();
Index: code/trunk/src/modules/overlays/hud/HUDNavigation.cc
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDNavigation.cc	(revision 7380)
+++ code/trunk/src/modules/overlays/hud/HUDNavigation.cc	(revision 7401)
@@ -90,11 +90,11 @@
 }
 
-void HUDNavigation::XMLPort ( Element& xmlElement, XMLPort::Mode mode )
-{
-    SUPER ( HUDNavigation, XMLPort, xmlElement, mode );
-
-    XMLPortParam ( HUDNavigation, "font",          setFont,          getFont,          xmlElement, mode );
-    XMLPortParam ( HUDNavigation, "textSize",      setTextSize,      getTextSize,      xmlElement, mode );
-    XMLPortParam ( HUDNavigation, "navMarkerSize", setNavMarkerSize, getNavMarkerSize, xmlElement, mode );
+void HUDNavigation::XMLPort ( Element& xmlelement, XMLPort::Mode mode )
+{
+    SUPER ( HUDNavigation, XMLPort, xmlelement, mode );
+
+    XMLPortParam ( HUDNavigation, "font",          setFont,          getFont,          xmlelement, mode );
+    XMLPortParam ( HUDNavigation, "textSize",      setTextSize,      getTextSize,      xmlelement, mode );
+    XMLPortParam ( HUDNavigation, "navMarkerSize", setNavMarkerSize, getNavMarkerSize, xmlelement, mode );
 }
 
Index: code/trunk/src/modules/overlays/hud/HUDNavigation.h
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDNavigation.h	(revision 7380)
+++ code/trunk/src/modules/overlays/hud/HUDNavigation.h	(revision 7401)
@@ -51,5 +51,5 @@
     void setConfigValues();
 
-    virtual void XMLPort ( Element& xmlElement, XMLPort::Mode mode );
+    virtual void XMLPort ( Element& xmlelement, XMLPort::Mode mode );
     virtual void tick ( float dt );
 
Index: code/trunk/src/modules/overlays/hud/HUDRadar.cc
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDRadar.cc	(revision 7380)
+++ code/trunk/src/modules/overlays/hud/HUDRadar.cc	(revision 7401)
@@ -82,11 +82,11 @@
     }
 
-    void HUDRadar::XMLPort(Element& xmlElement, XMLPort::Mode mode)
+    void HUDRadar::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
-        SUPER(HUDRadar, XMLPort, xmlElement, mode);
+        SUPER(HUDRadar, XMLPort, xmlelement, mode);
 
-        XMLPortParam(HUDRadar, "sensitivity", setRadarSensitivity, getRadarSensitivity, xmlElement, mode);
-        XMLPortParam(HUDRadar, "halfDotSizeDistance", setHalfDotSizeDistance, getHalfDotSizeDistance, xmlElement, mode);
-        XMLPortParam(HUDRadar, "maximumDotSize", setMaximumDotSize, getMaximumDotSize, xmlElement, mode);
+        XMLPortParam(HUDRadar, "sensitivity", setRadarSensitivity, getRadarSensitivity, xmlelement, mode);
+        XMLPortParam(HUDRadar, "halfDotSizeDistance", setHalfDotSizeDistance, getHalfDotSizeDistance, xmlelement, mode);
+        XMLPortParam(HUDRadar, "maximumDotSize", setMaximumDotSize, getMaximumDotSize, xmlelement, mode);
     }
 
Index: code/trunk/src/modules/overlays/hud/HUDRadar.h
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDRadar.h	(revision 7380)
+++ code/trunk/src/modules/overlays/hud/HUDRadar.h	(revision 7401)
@@ -49,5 +49,5 @@
         virtual ~HUDRadar();
 
-        virtual void XMLPort(Element& xmlElement, XMLPort::Mode mode);
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
         virtual void changedOwner();
 
Index: code/trunk/src/modules/overlays/stats/Scoreboard.cc
===================================================================
--- code/trunk/src/modules/overlays/stats/Scoreboard.cc	(revision 7380)
+++ code/trunk/src/modules/overlays/stats/Scoreboard.cc	(revision 7401)
@@ -54,12 +54,4 @@
             this->lines_.pop_back();
         }
-    }
-
-    /**
-        @brief Initializes the lines.
-    */
-    void Scoreboard::XMLPort(Element& xmlElement, XMLPort::Mode mode)
-    {
-        SUPER(Scoreboard, XMLPort, xmlElement, mode);
     }
 
Index: code/trunk/src/modules/overlays/stats/Scoreboard.h
===================================================================
--- code/trunk/src/modules/overlays/stats/Scoreboard.h	(revision 7380)
+++ code/trunk/src/modules/overlays/stats/Scoreboard.h	(revision 7401)
@@ -44,5 +44,4 @@
         virtual ~Scoreboard();
 
-        virtual void XMLPort(Element& xmlElement, XMLPort::Mode mode);
         virtual void tick(float dt);
 
Index: code/trunk/src/modules/overlays/stats/Stats.cc
===================================================================
--- code/trunk/src/modules/overlays/stats/Stats.cc	(revision 7380)
+++ code/trunk/src/modules/overlays/stats/Stats.cc	(revision 7401)
@@ -98,12 +98,4 @@
     }
 
-    /**
-        @brief Initializes the Stats panel.
-    */
-    void Stats::XMLPort(Element& xmlElement, XMLPort::Mode mode)
-    {
-        OrxonoxOverlay::XMLPort(xmlElement, mode);
-    }
-
     void Stats::tick(float dt)
     {
Index: code/trunk/src/modules/overlays/stats/Stats.h
===================================================================
--- code/trunk/src/modules/overlays/stats/Stats.h	(revision 7380)
+++ code/trunk/src/modules/overlays/stats/Stats.h	(revision 7401)
@@ -46,6 +46,4 @@
         void setConfigValues();
 
-        virtual void XMLPort(Element& xmlElement, XMLPort::Mode mode);
-
         virtual void tick(float dt);
 
Index: code/trunk/src/modules/pickup/DroppedPickup.cc
===================================================================
--- code/trunk/src/modules/pickup/DroppedPickup.cc	(revision 7380)
+++ code/trunk/src/modules/pickup/DroppedPickup.cc	(revision 7401)
@@ -61,6 +61,6 @@
     @param pickup
         The Pickupable that was dropped.
-    @param position
-        The position at which the DroppedPickup should be created.
+    @param carrier
+        The PickupCarrier that carried the input pickup before it was dropped.
     @param triggerDistance
         The distance at which the PickupSpawner triggers. Default is 10.
Index: code/trunk/src/modules/pickup/Pickup.cc
===================================================================
--- code/trunk/src/modules/pickup/Pickup.cc	(revision 7380)
+++ code/trunk/src/modules/pickup/Pickup.cc	(revision 7401)
@@ -225,6 +225,4 @@
         This method must be implemented by any class directly inheriting from Pickupable. It is most easily done by just creating a new DroppedPickup, e.g.:
         DroppedPickup(BaseObject* creator, Pickupable* pickup, const Vector3& position);
-    @param position
-        The position at which the PickupSpawner should be placed.
     @return
         Returns true if a spawner was created, false if not.
Index: code/trunk/src/modules/pickup/PickupCollection.cc
===================================================================
--- code/trunk/src/modules/pickup/PickupCollection.cc	(revision 7380)
+++ code/trunk/src/modules/pickup/PickupCollection.cc	(revision 7401)
@@ -228,6 +228,6 @@
     @brief
         Get whether a given class, represented by the input Identifier, is a target of this PickupCollection.
-    @param identifier
-        A pointer to the PickupIdentifier of the PickupCarrier we want to know of, whether it is a target of this PickupCollection.
+    @param carrier
+        A pointer to the PickupCarrier we want to know of, whether it is a target of this PickupCollection.
     @return
         Returns true if the PickupCarrier identified by the input PickupIdentififer it is a target of this PickupCollection, false if not.
@@ -336,6 +336,4 @@
         This method must be implemented by any class directly inheriting from Pickupable. It is most easily done by just creating a new DroppedPickup, e.g.:
         DroppedPickup(BaseObject* creator, Pickupable* pickup, const Vector3& position);
-    @param position
-        The position at which the PickupSpawner should be placed.
     @return
         Returns true if a spawner was created, false if not.
Index: code/trunk/src/modules/pickup/PickupCollectionIdentifier.cc
===================================================================
--- code/trunk/src/modules/pickup/PickupCollectionIdentifier.cc	(revision 7380)
+++ code/trunk/src/modules/pickup/PickupCollectionIdentifier.cc	(revision 7401)
@@ -99,5 +99,5 @@
     @brief
         Add a Pickupable to the PickupCollectionIdentifier.
-    @param
+    @param identifier
         A pointer to the PickupIdentifier of the Pickupable to be added.
     */
Index: code/trunk/src/modules/pickup/PickupSpawner.cc
===================================================================
--- code/trunk/src/modules/pickup/PickupSpawner.cc	(revision 7380)
+++ code/trunk/src/modules/pickup/PickupSpawner.cc	(revision 7401)
@@ -70,5 +70,5 @@
     @param respawnTime
         The minimum time between two spawns.
-    @param maySpawnedItems
+    @param maxSpawnedItems
         The maximum number of items spawned by this PickupSpawner.
     */
Index: code/trunk/src/modules/pickup/items/SpeedPickup.cc
===================================================================
--- code/trunk/src/modules/pickup/items/SpeedPickup.cc	(revision 7380)
+++ code/trunk/src/modules/pickup/items/SpeedPickup.cc	(revision 7401)
@@ -252,5 +252,5 @@
     @brief
         Sets the SpeedMultiply
-    @param speedAdd
+    @param speedMultiply
         The multiplied Speed
     */
Index: code/trunk/src/modules/questsystem/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/questsystem/CMakeLists.txt	(revision 7380)
+++ code/trunk/src/modules/questsystem/CMakeLists.txt	(revision 7401)
@@ -1,9 +1,3 @@
 SET_SOURCE_FILES(QUESTSYSTEM_SRC_FILES
-  AddQuest.cc
-  AddQuestHint.cc
-  AddReward.cc
-  ChangeQuestStatus.cc
-  CompleteQuest.cc
-  FailQuest.cc
   GlobalQuest.cc
   LocalQuest.cc
@@ -18,4 +12,6 @@
   QuestNotification.cc
 )
+
+ADD_SUBDIRECTORY(effects)
 
 ORXONOX_ADD_LIBRARY(questsystem
Index: code/trunk/src/modules/questsystem/GlobalQuest.h
===================================================================
--- code/trunk/src/modules/questsystem/GlobalQuest.h	(revision 7380)
+++ code/trunk/src/modules/questsystem/GlobalQuest.h	(revision 7401)
@@ -50,5 +50,6 @@
         Creating a GlobalQuest through XML goes as follows:
 
-        <GlobalQuest id="questId"> //Where questId is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information
+        @code
+        <GlobalQuest id="questId">
             <QuestDescription title="Title" description="Description." /> //The description of the quest.
             <subquests>
@@ -78,4 +79,5 @@
             </reward-effects>
         </GlobalQuest>
+        @endcode
     @author
         Damian 'Mozork' Frick
Index: code/trunk/src/modules/questsystem/LocalQuest.h
===================================================================
--- code/trunk/src/modules/questsystem/LocalQuest.h	(revision 7380)
+++ code/trunk/src/modules/questsystem/LocalQuest.h	(revision 7401)
@@ -49,5 +49,6 @@
         Creating a LocalQuest through XML goes as follows:
 
-        <LocalQuest id="questId"> //Where questId is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information
+        @code
+        <LocalQuest id="questId">
             <QuestDescription title="Title" description="Description." /> //The description of the quest.
             <subquests>
@@ -72,4 +73,5 @@
             </complete-effects>
         </LocalQuest>
+        @endcode
     @author
         Damian 'Mozork' Frick
Index: code/trunk/src/modules/questsystem/Quest.cc
===================================================================
--- code/trunk/src/modules/questsystem/Quest.cc	(revision 7380)
+++ code/trunk/src/modules/questsystem/Quest.cc	(revision 7401)
@@ -197,5 +197,5 @@
     @brief
         Returns the subquest at the given index.
-    @param
+    @param index
         The index.
     @return
@@ -222,5 +222,5 @@
     @brief
         Returns the QuestHint at the given index.
-    @param
+    @param index
         The index.
     @return
@@ -246,5 +246,5 @@
     @brief
         Returns the fail QuestEffect at the given index.
-    @param
+    @param index
         The index.
     @return
@@ -270,5 +270,5 @@
     @brief
         Returns the complete QuestEffect at the given index.
-    @param
+    @param index
         The index.
     @return
Index: code/trunk/src/modules/questsystem/QuestDescription.h
===================================================================
--- code/trunk/src/modules/questsystem/QuestDescription.h	(revision 7380)
+++ code/trunk/src/modules/questsystem/QuestDescription.h	(revision 7401)
@@ -50,5 +50,7 @@
         Creating a QuestDescription through XML goes as follows:
 
+        @code
         <QuestDescription title="Title" description="Description Text" failMessage="You fail." completeMessage="You win!" />
+        @endcode
     @author
         Damian 'Mozork' Frick
Index: code/trunk/src/modules/questsystem/QuestEffectBeacon.cc
===================================================================
--- code/trunk/src/modules/questsystem/QuestEffectBeacon.cc	(revision 7380)
+++ code/trunk/src/modules/questsystem/QuestEffectBeacon.cc	(revision 7401)
@@ -92,4 +92,6 @@
         Executes the QuestEffectBeacon.
         This means extracting the Pawn from the PlayerTrigger, provided by the Event causing the execution, and the extracting the PlayerInfo from the received Pawn and invoking the QuestEffectbeacon's QuestEffects on the received PlayerInfo.
+    @param bTriggered
+        true means the trigger was activated while false means it was deactivated
     @param trigger
         A pointer to the PlayerTrigger that threw the Event.
@@ -97,7 +99,7 @@
         Returns true if successfully executed, false if not.
     */
-    bool QuestEffectBeacon::execute(bool b, BaseObject* trigger)
-    {
-        if(!b)
+    bool QuestEffectBeacon::execute(bool bTriggered, BaseObject* trigger)
+    {
+        if(!bTriggered)
         {
             return false;
Index: code/trunk/src/modules/questsystem/QuestEffectBeacon.h
===================================================================
--- code/trunk/src/modules/questsystem/QuestEffectBeacon.h	(revision 7380)
+++ code/trunk/src/modules/questsystem/QuestEffectBeacon.h	(revision 7401)
@@ -61,4 +61,5 @@
         Creating a QuestEffectBeacon through XML goes as follows:
 
+        @code
         <QuestEffectBeacon times=n> //Where 'n' is eighter a number >= 0, which means the QuestEffectBeacon can be executed n times. Or n = -1, which means the QuestEffectBeacon can be executed an infinite number of times.
             <effects>
@@ -76,4 +77,5 @@
             </attached>
         </QuestEffectBeacon>
+        @endcode
     @author
         Damian 'Mozork' Frick
@@ -88,5 +90,5 @@
             virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode);
 
-            bool execute(bool b, BaseObject* trigger); //!< Executes the QuestEffects of the QuestEffectBeacon.
+            bool execute(bool bTriggered, BaseObject* trigger); //!< Executes the QuestEffects of the QuestEffectBeacon.
 
             /**
Index: code/trunk/src/modules/questsystem/QuestHint.h
===================================================================
--- code/trunk/src/modules/questsystem/QuestHint.h	(revision 7380)
+++ code/trunk/src/modules/questsystem/QuestHint.h	(revision 7401)
@@ -60,7 +60,9 @@
         Creating a QuestHint through XML goes as follows:
 
-        <QuestHint id="hintId">  //Where hintId is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information
+        @code
+        <QuestHint id="hintId">
             <QuestDesctription title="" description="" />
         </QuestHint>
+        @endcode
     @author
         Damian 'Mozork' Frick
Index: code/trunk/src/modules/questsystem/QuestItem.cc
===================================================================
--- code/trunk/src/modules/questsystem/QuestItem.cc	(revision 7380)
+++ code/trunk/src/modules/questsystem/QuestItem.cc	(revision 7401)
@@ -78,5 +78,7 @@
     @brief
         Sets the id of the QuestItem.
-    The id must be of GUID form. See 'http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure' for more information.
+        The id can be any string and must be unique in the context it is used (commonly a level file). To ensure uniqueness one could use GUIDs, however they are in general less readable, so make your own choice.
+    @see
+        http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure
     @param id
         The id to be set.
Index: code/trunk/src/modules/questsystem/QuestItem.h
===================================================================
--- code/trunk/src/modules/questsystem/QuestItem.h	(revision 7380)
+++ code/trunk/src/modules/questsystem/QuestItem.h	(revision 7401)
@@ -98,5 +98,5 @@
 
         private:
-            std::string id_; //!< Identifier. Should be of GUID form: http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure
+            std::string id_; //!< Identifier. Must be unique.
             QuestDescription* description_; //!< The QuestDescription of the QuestItem.
 
Index: code/trunk/src/modules/questsystem/QuestListener.h
===================================================================
--- code/trunk/src/modules/questsystem/QuestListener.h	(revision 7380)
+++ code/trunk/src/modules/questsystem/QuestListener.h	(revision 7401)
@@ -62,4 +62,5 @@
         You can use the QuestListener as if it were a Trigger or EventListener, that fires an Event when the status (depending on the set mode) of the given Quest changes.
 
+        @code
         <BaseObject> // The object that should react to the status change of a Quest.
             <events>
@@ -69,4 +70,5 @@
             </events>
         </BaseObject>
+        @endcode
     @author
     Damian 'Mozork' Frick
Index: code/trunk/src/modules/questsystem/QuestNotification.cc
===================================================================
--- code/trunk/src/modules/questsystem/QuestNotification.cc	(revision 7380)
+++ code/trunk/src/modules/questsystem/QuestNotification.cc	(revision 7401)
@@ -48,4 +48,6 @@
     @brief
         Creates a QuestNotification with the input message.
+    @param creator
+        The creator of this object
     @param message
         The message to be sent.
Index: code/trunk/src/modules/questsystem/effects/AddQuest.cc
===================================================================
--- code/trunk/src/modules/questsystem/effects/AddQuest.cc	(revision 7401)
+++ code/trunk/src/modules/questsystem/effects/AddQuest.cc	(revision 7401)
@@ -0,0 +1,110 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Damian 'Mozork' Frick
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Implementation of the AddQuest class.
+*/
+
+#include "AddQuest.h"
+
+#include "util/Exception.h"
+#include "core/CoreIncludes.h"
+#include "questsystem/QuestManager.h"
+#include "questsystem/Quest.h"
+
+namespace orxonox
+{
+    CreateFactory(AddQuest);
+
+    /**
+    @brief
+        Constructor. Registers the object.
+    */
+    AddQuest::AddQuest(BaseObject* creator) : ChangeQuestStatus(creator)
+    {
+        RegisterObject(AddQuest);
+    }
+
+    /**
+    @brief
+        Destructor.
+    */
+    AddQuest::~AddQuest()
+    {
+    }
+
+    /**
+    @brief
+        Method for creating a AddQuest object through XML.
+    */
+    void AddQuest::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(AddQuest, XMLPort, xmlelement, mode);
+
+        COUT(4) << "New AddQuest, with target Quest {" << this->getQuestId() << "}, created." << std::endl;
+    }
+
+    /**
+    @brief
+        Invokes the QuestEffect.
+    @param player
+        The player the QuestEffect is invoked on.
+    @return
+        Returns true if the QuestEffect was successfully invoked.
+    */
+    bool AddQuest::invoke(PlayerInfo* player)
+    {
+        if(player == NULL) //!< Null-pointers are badass.
+        {
+            COUT(2) << "Input player is NULL." << std::endl;
+            return false;
+        }
+
+        COUT(5) << "AddQuest on player: " << player << " ." << std::endl;
+
+        try
+        {
+            Quest* quest = QuestManager::getInstance().findQuest(this->getQuestId());
+            if(quest == NULL || !quest->start(player))
+            {
+               return false;
+            }
+        }
+        catch(const orxonox::Exception& ex)
+        {
+            COUT(2) << ex.getFullDescription() << std::endl;
+            return false;
+        }
+
+        COUT(4) << "Quest {" << this->getQuestId() << "} successfully added to player: " << player << " ." << std::endl;
+        return true;
+    }
+
+
+}
Index: code/trunk/src/modules/questsystem/effects/AddQuest.h
===================================================================
--- code/trunk/src/modules/questsystem/effects/AddQuest.h	(revision 7401)
+++ code/trunk/src/modules/questsystem/effects/AddQuest.h	(revision 7401)
@@ -0,0 +1,68 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Damian 'Mozork' Frick
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Definition of the AddQuest class.
+*/
+
+#ifndef _AddQuest_H__
+#define _AddQuest_H__
+
+#include "questsystem/QuestsystemPrereqs.h"
+#include "ChangeQuestStatus.h"
+
+namespace orxonox
+{
+    /**
+    @brief
+        Adds a Quest, resp. changes the quests status to active for the player invoking the Quest.
+
+        Creating a AddQuest through XML goes as follows:
+
+        @code
+        <AddQuest questId="id" />  //Where id identifies the Quest that should be added.
+        @endcode
+    @author
+        Damian 'Mozork' Frick
+    */
+    class _QuestsystemExport AddQuest : public ChangeQuestStatus
+    {
+        public:
+        AddQuest(BaseObject* creator);
+        virtual ~AddQuest();
+
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a AddQuest object through XML.
+
+        virtual bool invoke(PlayerInfo* player); //!< Invokes the QuestEffect.
+
+    };
+
+}
+
+#endif /* _AddQuest_H__ */
Index: code/trunk/src/modules/questsystem/effects/AddQuestHint.cc
===================================================================
--- code/trunk/src/modules/questsystem/effects/AddQuestHint.cc	(revision 7401)
+++ code/trunk/src/modules/questsystem/effects/AddQuestHint.cc	(revision 7401)
@@ -0,0 +1,133 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Damian 'Mozork' Frick
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file
+    @brief Implementation of the AddQuestHint class.
+*/
+
+#include "AddQuestHint.h"
+
+#include "util/Exception.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "questsystem/QuestManager.h"
+#include "questsystem/QuestItem.h"
+#include "questsystem/QuestHint.h"
+
+namespace orxonox
+{
+    CreateFactory(AddQuestHint);
+
+    /**
+    @brief
+        Constructor. Registers the object.
+    */
+    AddQuestHint::AddQuestHint(BaseObject* creator) : QuestEffect(creator)
+    {
+        RegisterObject(AddQuestHint);
+    }
+
+    /**
+    @brief
+        Destructor.
+    */
+    AddQuestHint::~AddQuestHint()
+    {
+    }
+
+    /**
+    @brief
+        Method for creating a AddQuestHint object through XML.
+    */
+    void AddQuestHint::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(AddQuestHint, XMLPort, xmlelement, mode);
+
+        XMLPortParam(AddQuestHint, "hintId", setHintId, getHintId, xmlelement, mode);
+
+        COUT(4) << "New AddQuestHint, with target QuestHint {" << this->getHintId() << "}, created." << std::endl;
+    }
+
+    /**
+    @brief
+        Sets the id of the QuestHint to be added to the player the QuestEffect is invoked on.
+    @param id
+        The QuestHint id.
+    @return
+        Returns true if successful.
+    */
+    bool AddQuestHint::setHintId(const std::string & id)
+    {
+        if(id.compare(BLANKSTRING) == 0)
+        {
+            COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
+            return false;
+        }
+
+        this->hintId_ = id;
+        return true;
+    }
+
+    /**
+    @brief
+        Invokes the QuestEffect.
+    @param player
+        The player.
+    @return
+        Returns true if the QuestEffect was successfully invoked.
+    */
+    bool AddQuestHint::invoke(PlayerInfo* player)
+    {
+        if(player == NULL) //!< NULL-pointers are evil!
+        {
+            COUT(2) << "The input player is NULL." << std::endl;
+            return false;
+        }
+
+        COUT(5) << "AddQuestHint on player: " << player << " ." << std::endl;
+
+        try
+        {
+            QuestHint* hint = QuestManager::getInstance().findHint(this->hintId_);
+            if(hint == NULL || !hint->setActive(player))
+            {
+                return false;
+            }
+        }
+        catch(const Exception& e)
+        {
+           COUT(2) << e.getFullDescription() << std::endl;
+           return false;
+        }
+
+        COUT(4) << "QuestHint {" << this->getHintId() << "} successfully added to player: " << player << " ." << std::endl;
+        return true;
+
+    }
+}
